# -*- coding: utf-8 -*-
"""
Created on Mon Oct 24 02:22:56 2022

@author: noga mudrik
"""

from sklearn import svm
from sklearn.model_selection import train_test_split
# human = label 0
# AI = label 1
import sqlite3
import pandas as pd
import json
import os
import numpy as np
import gensim
import gensim.downloader
from sklearn.model_selection import KFold
glove_vectors = gensim.downloader.load('glove-twitter-25')

def return_emb_vec(word):
  try: 
    vec = glove_vectors[word.lower().strip()].reshape((1,-1))
  except:
    vec = np.zeros((1,len(glove_vectors['hi']))).reshape((1,-1))
  return vec

save_path = r'C:\Users\noga mudrik\Documents\turing_associations\from_sep_30_files'
cue_words_list = np.load(save_path + os.sep +'all_cue_words_october_1.npy')

path_model_ass = r'C:\Users\noga mudrik\Documents\turing_associations\turing_experiment\static\dataset\AI'
guess_human_path1 =r'C:\Users\noga mudrik\Documents\turing_associations\prompt_folder\all_human_prompts.npy'
guess_human_path2 = r'C:\Users\noga mudrik\Documents\turing_associations\mturk_turing_associations_oct\all_human_free.npy'
guess_AI_path = r'C:\Users\noga mudrik\Documents\turing_associations\turing_experiment\static\dataset\AI'
dict_numbers_to_model_name = np.load('dict_numbers_to_model_name.npy',allow_pickle=True).item()

words_humans = list(np.load(guess_human_path1)) + list(np.load(guess_human_path2))
#np.load(r'C:\Users\noga mudrik\Documents\turing_associations\from_sep_30_files\words_humans.npy')    
numSplits = 10     # Number of splits for cross-validation

store_predictions = {}
store_acc = {}
store_conf = {}
store_predictions_test = {}
store_acc_test = {}
store_conf_test = {}
store_mean_diag = {}
try:
    embeddings_store
except:
    embeddings_store = {}
    embeddings_humans = np.vstack([return_emb_vec(w) for w in words_humans])
    embeddings_store['human'] = embeddings_humans
for number,model in dict_numbers_to_model_name.items():
    dict_model_cue_guess = np.load(path_model_ass+ os.sep + str(number) + os.sep + 'dict_cue_guess.npy', 
            allow_pickle=True).item()
    model_guess = [dict_model_cue_guess[cue] for cue in cue_words_list]
    embeddings_models = np.vstack([return_emb_vec(w) for w in model_guess])
    embeddings_store[model] = embeddings_models
    labels = np.hstack([np.zeros(len(embeddings_humans)), np.ones(len(embeddings_models))])
    x = np.vstack([embeddings_humans, embeddings_models])
    #X_train, X_test, y_train, y_test = train_test_split(x, labels, test_size=0.33, random_state=42)
    store_conf[model] = []
    store_predictions[model] = []
    store_acc[model] = []
    store_mean_diag[model] = []
    kf = KFold(n_splits=numSplits,shuffle=True)
    for (i,(train_index, test_index)) in enumerate(kf.split(x)):
        X_train = x[train_index]
        y_train = labels[train_index]
        X_test =  x[test_index]
        y_test = labels[test_index]
            
        ## Train train
        clf = svm.SVC()
        clf.fit(X_train, labels_train)
        predictions = clf.predict(x_test)
        store_predictions[model].append(predictions)
        acc = np.mean(predictions == y_test)
        store_acc[model].append(acc)
        confmat = np.zeros((2,2))
        
        # rows = true; cols = guess; 
        confmat[0,0] = np.sum((predictions == 0) & (y_test == 0))
        confmat[0,1] = np.sum((predictions == 1) & (y_test == 0))
        confmat[1,0] = np.sum((predictions == 0) & (y_test == 1))
        confmat[1,1] = np.sum((predictions == 1) & (y_test == 1))
        store_conf[model].append(confmat)
        store_mean_diag[model].append(confmat[0,0]*0.5 + 0.5*confmat[1,1])
    #display(confmat)
    
# import matplotlib.pyplot as plt
# import seaborn as sns
# import pandas as pd
# alpha = 0.6
# titles = ['Abs Counts', 'Normalized by Real', 'Normalized by Guess']
# fig, ax = plt.subplots(len(store_conf),3)
# for model_count, model in enumerate(store_conf.keys()):
#     df_results_c = pd.DataFrame(store_conf[model], columns = ['human','AI'], index = ['human','AI'])
#     sns.heatmap(df_results_c, alpha = alpha, ax  = ax[model_count, 0], annot =True, fmt = ".2f")
#     sns.heatmap(df_results_c/df_results_c.sum(axis = 1).values.reshape((-1,1)), alpha = alpha, ax = ax[model_count,1], vmin = 0, vmax = 1, annot = True)
#     sns.heatmap(df_results_c/df_results_c.sum(axis = 0),alpha = alpha, ax = ax[model_count,2], vmin = 0, vmax = 1, annot=True)
#     [ax_spec.set_title(model + ': \n ' + titles[i], fontsize = 12) for i,ax_spec in enumerate(ax[model_count])]

# #[[ax_spec.set_title(titles[i] + dict_, fontsize = 16) for i,ax_spec in enumerate(ax_i)] for ax_i_count,ax_i in enumerate(ax)]

# #dict_numbers_to_model_name = np.load('dict_numbers_to_model_name.npy',allow_pickle=True).item()

# [ax_spec.set_xlabel('Guess', fontsize = 11) for ax_spec in ax.flatten()]
# [ax_spec.set_ylabel('real', fontsize = 11) for ax_spec in ax.flatten()]

# fig, ax = plt.subplots(len(store_conf),3)
# for model_count, model in enumerate(store_conf_test.keys()):
#     df_results_c = pd.DataFrame(store_conf_test[model], columns = ['human','AI'], index = ['human','AI'])
#     sns.heatmap(df_results_c, alpha = alpha, ax  = ax[model_count, 0], annot =True, fmt = ".2f")
#     sns.heatmap(df_results_c/df_results_c.sum(axis = 1).values.reshape((-1,1)), alpha = alpha, ax = ax[model_count,1], vmin = 0, vmax = 1, annot = True)
#     sns.heatmap(df_results_c/df_results_c.sum(axis = 0),alpha = alpha, ax = ax[model_count,2], vmin = 0, vmax = 1, annot=True)
#     [ax_spec.set_title(model + ': \n ' + titles[i], fontsize = 12) for i,ax_spec in enumerate(ax[model_count])]

# #[[ax_spec.set_title(titles[i] + dict_, fontsize = 16) for i,ax_spec in enumerate(ax_i)] for ax_i_count,ax_i in enumerate(ax)]

# #dict_numbers_to_model_name = np.load('dict_numbers_to_model_name.npy',allow_pickle=True).item()

# [ax_spec.set_xlabel('Guess', fontsize = 11) for ax_spec in ax.flatten()]
# [ax_spec.set_ylabel('real', fontsize = 11) for ax_spec in ax.flatten()]